OpenVDB: ArgumentIterator< SignatureT, I > Struct Template Reference

OpenVDB 13.0.0

Loading...
Searching...
No Matches
ArgumentIterator< SignatureT, I > Struct Template Reference

Templated argument iterator which implements various small functions per argument type, resolved at compile time. More...

`#include <openvdb_ax/codegen/FunctionTypes.h>`

## Public Types
using | ArgT = typename FunctionTraits<SignatureT>::template Arg<I-1>
using | ArgumentValueType = typename ArgT::Type

## Static Public Member Functions
template<typename OpT>
static void | apply (const OpT &op, const bool forwards)

## Static Public Attributes
static const bool | IsNativeSignature
| Whether this signature contains types that are representable in AX's Value type.

## Detailed Description

template<typename SignatureT, size_t I = FunctionTraits<SignatureT>::N_ARGS>
struct openvdb::v13_0::ax::codegen::ArgumentIterator< SignatureT, I >

Templated argument iterator which implements various small functions per argument type, resolved at compile time.

## Member Typedef Documentation

## ◆ ArgT

template<typename SignatureT, size_t I = FunctionTraits<SignatureT>::N_ARGS>

using ArgT = typename FunctionTraits<SignatureT>::template Arg<I-1>

## ◆ ArgumentValueType

template<typename SignatureT, size_t I = FunctionTraits<SignatureT>::N_ARGS>

using ArgumentValueType = typename ArgT::Type

## Member Function Documentation

## ◆ apply()

template<typename SignatureT, size_t I = FunctionTraits<SignatureT>::N_ARGS>
template<typename OpT>

void apply | ( | const OpT & | op,
|  | const bool | forwards )
| inlinestatic

## Member Data Documentation

## ◆ IsNativeSignature

template<typename SignatureT, size_t I = FunctionTraits<SignatureT>::N_ARGS>

const bool IsNativeSignature
| static

Initial value:
=
LLVMType<ArgumentValueType>::CXXUTypeIsNativeType &&
ArgumentIterator<SignatureT, I-1>::IsNativeSignature
openvdb::v13_0::ax::codegen::ArgumentIterator
Templated argument iterator which implements various small functions per argument type,...
Definition FunctionTypes.h:189
openvdb::v13_0::ax::codegen::ArgumentIterator::IsNativeSignature
static const bool IsNativeSignature
Whether this signature contains types that are representable in AX's Value type.
Definition FunctionTypes.h:195
openvdb::v13_0::ax::codegen::LLVMType::CXXUTypeIsNativeType
static const bool CXXUTypeIsNativeType
Definition Types.h:76

Whether this signature contains types that are representable in AX's Value type.